"use strict";
/**
 * @author Olsi Rrjolli
 */
Object.defineProperty(exports, "__esModule", { value: true });
const ControllerRegistry_1 = require("../ControllerRegistry");
/**
 * Execute the Book Store method which will needed
 * @param awsRequestEvent
 *  The awsRequestEvent (httpMethod, resource...)
 *  @throws MethodExecuteError
 *    If the method can't execute
 */
exports.execute = (awsRequestEvent) => {
    let methodInformation;
    return Promise.resolve().then(() => {
        methodInformation = ControllerRegistry_1.default.controllerScan(awsRequestEvent);
        return Reflect.apply(methodInformation.toCallMethod, undefined, methodInformation.args);
    }).catch((error) => {
        if (methodInformation) {
            console.trace('Execution error for selected method:', methodInformation.toCallMethod.name, error);
        }
        return Promise.reject(error);
    });
};
//# sourceMappingURL=awsUtils.js.map